public class FibTaskCombine extends CXTask {

   //synthetic delay 
   private int combineDelay=100;

   // required constructor!   
   public FibTaskCombine(TaskHeader taskHeader) {
      super(taskHeader);
   }    

   // custom constructor(s)
   public FibTaskCombine()
    {
      //the rest parameters will be set by your task container
      inputArguments=new Integer[2];
      missingInputArguments=2;
      
      outputDestination=new DestinationRecord[1]; // the destination for the result of this task's execution
                      
    }

   // that's the only method you must override
   public void executeTask(TaskContainer ts)
    {

       //add some synthetic delay ...
	 createWorkLoad(combineDelay);	
		
       // get input arguments
       //in our case, input arguments correspond to the output of the fib(num-1) and fib(num-2) tasks       
       Integer fibNumber1= (Integer) inputArguments[0];
       Integer fibNumber2= (Integer) inputArguments[1];
           
       int fnum1=fibNumber1.intValue();
       int fnum2=fibNumber2.intValue();
      
       TaskInfo taskInfo;
       Sequence computedBy;
       long argPos;
       long jobId=0; 
       Integer[] result=new Integer[1];

       if (outputDestination[0].destinationTask!=null)
       // this means that the results are intermediate - will be send to another task
          { 
            taskInfo=new TaskInfo(outputDestination[0].destinationTask);
            argPos=outputDestination[0].inArgPos;
            jobId=taskInfo.jobId; 
          } 
       else 
          {
        // this means that the results are final - will be send to the originator 
            taskInfo=null; 
            jobId=myTaskInfo.jobId;
            argPos=0;
          }               

       result[0]=new Integer(fnum1+fnum2); // since fib(num)=fib(num-1)+f(num-2) 
                                           // fnum1--->fib(num-1)
                                           // fnum2--->fib(num-2)  
       computedBy=getComputedBy();  

       Result res=new Result(taskInfo,computedBy,argPos,result);
       res.jobId=jobId; 

       //finally, return the results to your task container
       ts.storeResults(res);

    }

    public void createWorkLoad(int aDelay)
	{
		int i,j,k;
		double a=1.0;
	
		for (i=0;i<aDelay;i++)
			for (j=0;j<aDelay;j++)
				for (k=0;k<aDelay;k++)
					a=a*1.0;
	}
   
  }
